'Gen.vbs. Argument(0) is the original database. Argument(2) is the transform file.
 
Option Explicit

' Check arguments
If WScript.Arguments.Count < 1 Then
    WScript.Echo "Usage is gen.vbs [original database]"
    WScript.Quit(1)
End If

'Copy file to temp directory
Const OverwriteExisting = True
Dim objFSO,currentdir,tempfile,strSourceDir,strMstFile,strKeyFilePath,nKeyFileSize

' check keyfile exist.
Set objFSO = Wscript.CreateObject("Scripting.FileSystemObject")
strKeyFilePath = Mid(Wscript.Arguments(0), 1, InStrRev(Wscript.Arguments(0), "\"))
If Not objFSO.FileExists(strKeyFilePath & "fpmkey.txt") then
	WScript.Echo "Can't find fpmkey.txt"
    WScript.Quit(2)
End If

nKeyFileSize = objFSO.GetFile(strKeyFilePath & "fpmkey.txt").Size

currentdir = left(Wscript.ScriptFullName,len(Wscript.ScriptFullName)-len(Wscript.ScriptName))
tempfile = currentdir & "test.msi.tmp"
strMstFile = strKeyFilePath & objFSO.GetBaseName(Wscript.Arguments(0)) & ".mst"
objFSO.CopyFile Wscript.Arguments(0),tempfile,OverwriteExisting

' Add license file resource
Dim ObjShell,query,WiRunSQL
set ObjShell = Wscript.CreateObject("wscript.shell")
WiRunSQL = chr(34) & currentdir & "WiRunSQL.vbs" & chr(34)
query = "INSERT INTO `File` (`File`.`File`,`File`.`Component_`,`File`.`FileName`,`File`.`FileSize`, `File`.`Version`,`File`.`Language`,`File`.`Attributes`,`File`.`Sequence`) VALUES ('fpmkey.txt','LicenseFilesComponent','fpmkey.txt'," & nKeyFileSize & ",'','',8192,1)"
ObjShell.Run WiRunSQL & chr(34) & tempfile & chr(34) & " " & chr(34) & query & chr(34),0,True
query = "INSERT INTO `Component` (`Component`.`Component`,`Component`.`ComponentId`,`Component`.`Directory_`, `Component`.`Attributes`,`Component`.`Condition`,`Component`.`KeyPath`) VALUES ('LicenseFilesComponent','{655B1398-7FE7-454A-AD45-6B3CEFCAE624}','SUBDIRECTORY',0,'','')"
ObjShell.Run WiRunSQL & chr(34) & tempfile & chr(34) & " " & chr(34) & query & chr(34),0,True
query = "INSERT INTO `Feature` (`Feature`.`Feature`,`Feature`.`Feature_Parent`,`Feature`.`Title`, `Feature`.`Description`,`Feature`.`Display`,`Feature`.`Level`,`Feature`.`Directory_`,`Feature`.`Attributes`) VALUES ('FX_LicenseFiles','','','',0,1,'',8)"
ObjShell.Run WiRunSQL & chr(34) & tempfile & chr(34) & " " & chr(34) & query & chr(34),0,True
query = "INSERT INTO `FeatureComponents` (`FeatureComponents`.`Feature_`,`FeatureComponents`.`Component_`) VALUES ('FX_LicenseFiles','LicenseFilesComponent')"
ObjShell.Run WiRunSQL & chr(34) & tempfile & chr(34) & " " & chr(34) & query & chr(34),0,true

' Connect to Windows Installer object
Const msiOpenDatabaseModeReadOnly = 0
Const msiOpenDatabaseModeTransact = 1
Dim installer : Set installer = Nothing
Set installer = Wscript.CreateObject("WindowsInstaller.Installer") 

' Open databases
Dim database1 : Set database1 = installer.OpenDatabase(Wscript.Arguments(0), msiOpenDatabaseModeReadOnly) 
Dim database2 : Set database2 = installer.OpenDatabase(tempfile, msiOpenDatabaseModeReadOnly) 

' Generate transform
Dim transform : transform = Database2.GenerateTransform(Database1, strMstFile)

' Create and add Summary Information
Dim transinfo : transinfo = Database2.CreateTransformSummaryInfo(Database1, strMstFile,0,0)

Set objFSO = Nothing
Set installer = Nothing
Set ObjShell = Nothing
